#!/bin/bash

FILE=/tmp/DiskInfo
CPUINFO=/usr/share/hardinfo/cpuinfo
cp /proc/io* /usr/share/hardinfo/
chmod a+r /usr/share/hardinfo/io*

DEVLIST=`lsblk | grep disk | awk '{print $1}'`
#echo ${DEVLIST}

if [ -f ${FILE} ]; then
	rm -rf ${FILE}
fi

for dev in ${DEVLIST}
do
	if [[ "$dev" == nvme* ]];then
		echo "sadsa"
		MODELNUME=`smartctl -a /dev/${dev} | grep "Model" | awk '{print $3,$4}'`
		SERIALNUM=`smartctl -a /dev/${dev} | grep "Serial" | awk '{print $3}'`
		FIRMWARE_VERSION=`smartctl -a /dev/${dev} | grep "Firmware Version" | awk '{print $3}'`
		PCI_VENDOR=`smartctl -a /dev/${dev} | grep "PCI Vendor/Subsystem ID" | awk '{print $4}'`
		IEEE_OUT_IDENTIFIER=`smartctl -a /dev/${dev} | grep "IEEE OUI Identifier" | awk '{print $4}'`
		CONTROLLER_ID=`smartctl -a /dev/${dev} | grep "Controller ID" | awk '{print $3}'`
		echo "${dev},${MODELNUME},${SERIALNUM},${FIRMWARE_VERSION},${PCI_VENDOR},${IEEE_OUT_IDENTIFIER},${CONTROLLER_ID}" >> ${FILE}
	fi
done
if [ -f ${FILE} ]; then
	chmod 0664 ${FILE}
fi
if [ -f ${CPUINFO} ]; then
        rm -rf ${CPUINFO}
fi
		dmidecode -t Processor >>  ${CPUINFO}
		LANG=C lscpu  >> ${CPUINFO}
		chmod a+r ${CPUINFO}
		MODE=mode:
		bit=`getconf LONG_BIT`
		spend=`dmidecode -t Processor | grep Max  | awk '{print $3}'`
		echo "spend_max: ${spend}" >> ${CPUINFO}
		echo "${MODE} ${bit}" >> ${CPUINFO}

memorytotal_path="/usr/share/hardinfo/memorytotal"
memtmp_path="/usr/share/hardinfo/memtmp"

dmidecode -t 'memory' | grep -A16 'Memory Device' | grep 'Size' | grep -iv 'No Module' > $memtmp_path
rm -rf $memorytotal_path

while read line
do
	unit=`echo ${line} | awk '{print $3}'`
	size=`echo ${line} | awk '{print $2}'`
	if [ "$unit" = "GB" ];then
		echo "  Size: $((size*1024)) MB" >> $memorytotal_path
	else
		echo "  Size: $((size)) MB" >> $memorytotal_path
	fi
done < $memtmp_path

chmod a+r $memorytotal_path
rm -rf $memtmp_path

